Attribute VB_Name = "mdlConvPDU"
Option Explicit

'              b7  0  0  0  0  1  1  1  1
'              b6  0  0  1  1  0  0  1  1
'              b5  0  1  0  2  0  1  0  1
'
' b4 b3 b2 b1      0  1  2  3  4  5  6  7
'
' 0  0  0  0   0   @  ?  SP 0    P  ?  p
' 0  0  0  1   1   ?  _  !  1  A  Q  a  q
' 0  0  1  0   2   $  ?  ?  2  B  R  b  r
' 0  0  1  1   3   ?  v  #  3  C  S  c  s
' 0  1  0  0   4   ?  ?    4  D  T  d  t
' 0  1  0  1   5   ?  ?  %  5  E  U  e  u
' 0  1  1  0   6   ?  ?  &  6  F  V  f  v
' 0  1  1  1   7   ?  ?    7  G  W  g  w
' 1  0  0  0   8   ?  ?  (  8  H  X  h  x
' 1  0  0  1   9   ?  ?  )  9  I  Y  i  y
' 1  0  1  0   10  LF ?  *  :  J  Z  j  z
' 1  0  1  1   11  ?     +  ;  K  ?  k  ?
' 1  1  0  0   12  ?  ?  ,  <  L  ?  l  ?
' 1  1  0  1   13  CR ?  -  =  M  ?  m  ?
' 1  1  1  0   14  ?  ?  .  >  N  ?  n  ?
' 1  1  1  1   15  ?  ?  /  ?  O    o  ?


Public Function TxtToPdu(sCell As String, sMess As String) As String
'   Y
Dim SCA As String, PDU As String, MR As String
Dim DA As String, PID As String, DCS As String
Dim VP As String, UDL As String, UD As String

SCA = "00"
PDU = ""                        'unreceived:"11"/received:"31")
If PDU = "" Then PDU = "11"     'default:unreceived

MR = "00"

'DA: Destination Address
DA = DecToHex(Len(sCell))       'Panjang sCell dlm Hex
DA = DA & IIf(Len(sCell) > 10, "91", "81") '"91":Int. Number(62...),"81":Loc. Number(081..)
DA = DA & RevNum(sCell)

PID = "00"
DCS = ""                        'Normal:"00",Flash:"F0"
If DCS = "" Then DCS = "00"     'default normal

VP = ""                         'Limit Period of delivery
If VP = "" Then VP = "FF"       'default: A7 - 1 days, FF - no period

UDL = DecToHex(Len(sMess))      'length of message in Hex
UD = CharHex(sMess, 8)          'Message in Hex 8bit /octet

TxtToPdu = SCA & PDU & MR & DA & PID & DCS & VP & UDL & UD 'Format of SMS Submit PDU

End Function


Public Function PduToTxt(msg As String) As String
' Y  
Dim FO As String, PID As String, DCS As String, SCTS As String
Dim UDL As String, UD As String, SCTS_Tgl As String, SCTS_Jam As String
Dim lnSCA As String, typeSCA As String, noSCA As String
Dim newMsg As String, lnOA As String, typeOA As String, noOA As String
Dim SCTS_a As String, SCTS_Tgl_a As String, SCTS_Jam_a As String
Dim IndexSend As String, RMsg As String

newMsg = msg
lnSCA = HexToDec(Left(msg, 2)) * 2      'length of SCA
newMsg = Right(newMsg, Len(newMsg) - 2)

typeSCA = Left(newMsg, 2)               '91:int,81:local
newMsg = Right(newMsg, Len(newMsg) - 2)

noSCA = RevNum(Left(newMsg, lnSCA - 2)) 'service center
If UCase(Right(noSCA, 1)) = "F" Then noSCA = Left(noSCA, Len(noSCA) - 1)
newMsg = Right(newMsg, Len(newMsg) - lnSCA + 2)

FO = Left(newMsg, 2)
newMsg = Right(newMsg, Len(newMsg) - 2)
If FO = "06" Then                       'code of send report (Indonesia)
    IndexSend = HexToDec(Left(newMsg, 2))
    newMsg = Right(newMsg, Len(newMsg) - 2)
End If

lnOA = HexToDec(Left(newMsg, 2))        'Origine Address
If lnOA Mod 2 <> 0 Then lnOA = lnOA + 1
newMsg = Right(newMsg, Len(newMsg) - 2)
typeOA = Left(newMsg, 2)
newMsg = Right(newMsg, Len(newMsg) - 2)

noOA = Left(newMsg, lnOA)
If typeOA = "D0" Then
    noOA = CharHex(noOA, 7)
Else
    noOA = RevNum(noOA)
    If UCase(Right(noOA, 1)) = "F" Then noOA = Left(noOA, Len(noOA) - 1)
End If
newMsg = Right(newMsg, Len(newMsg) - lnOA)

If FO <> "06" Then                      'if not report message
    PID = Left(newMsg, 2)
    newMsg = Right(newMsg, Len(newMsg) - 2)

    DCS = Left(newMsg, 2)
    newMsg = Right(newMsg, Len(newMsg) - 2)

    SCTS = RevNum(Left(newMsg, 14))
    SCTS_Tgl = Mid(SCTS, 3, 2) & "/" & Mid(SCTS, 5, 2) & "/20" & Mid(SCTS, 1, 2) 'mm/dd/yyyy,jj:mn
    SCTS_Jam = Mid(SCTS, 7, 2) & ":" & Mid(SCTS, 9, 2) & ":" & Mid(SCTS, 11, 2) 'hh:mm:dd
    newMsg = Right(newMsg, Len(newMsg) - 14)

    UDL = CInt(HexToDec(Left(newMsg, 2)))
    newMsg = Right(newMsg, Len(newMsg) - 2)
    
    If DCS = "08" Then                  ' USC2
        UD = CharHexRus(newMsg)
    Else                                ' 7 bit
        UD = CharHex(newMsg, 7)
        UD = Left(UD, UDL)
    End If
Else
    SCTS = RevNum(Left(newMsg, 14))
    SCTS_Tgl = Mid(SCTS, 3, 2) & "/" & Mid(SCTS, 5, 2) & "/20" & Mid(SCTS, 1, 2) 'mm/dd/yyyy,jj:mn
    SCTS_Jam = Mid(SCTS, 7, 2) & ":" & Mid(SCTS, 9, 2) & ":" & Mid(SCTS, 11, 2) 'hh:mm:dd
    newMsg = Right(newMsg, Len(newMsg) - 14)
    
    SCTS_a = RevNum(Left(newMsg, 14))
    SCTS_Tgl_a = Mid(SCTS_a, 3, 2) & "/" & Mid(SCTS_a, 5, 2) & "/20" & Mid(SCTS_a, 1, 2) 'mm/dd/yyyy,jj:mn
    SCTS_Jam_a = Mid(SCTS_a, 7, 2) & ":" & Mid(SCTS_a, 9, 2) & ":" & Mid(SCTS_a, 11, 2) 'hh:mm:dd
    
End If

RMsg = "Message= " & UD & vbCrLf
RMsg = RMsg & "FO = " & FO & vbCrLf
RMsg = RMsg & "SCA = " & noSCA & vbCrLf
RMsg = RMsg & "OA = " & noOA & vbCrLf
RMsg = RMsg & "DCS = " & DCS & vbCrLf
RMsg = RMsg & "Tgl = " & SCTS_Tgl & vbCrLf
RMsg = RMsg & "Jam = " & SCTS_Jam & vbCrLf
RMsg = RMsg & "Tgl_A = " & SCTS_Tgl_a & vbCrLf
RMsg = RMsg & "Jam_A = " & SCTS_Jam_a & vbCrLf
RMsg = RMsg & "IndexSend = " & IndexSend & vbCrLf
RMsg = RMsg & "UDL = " & UDL & vbCrLf

PduToTxt = RMsg
    
End Function





Private Function Biner(Bilangan) As String
Dim Basis As Integer, Hsltemp As Variant, sisa As Variant, HslBagi As Variant
Hsltemp = "": sisa = "": Basis = 2
Do
    Hsltemp = sisa & Hsltemp
    HslBagi = Bilangan \ Basis
    sisa = Bilangan Mod Basis
    Bilangan = HslBagi
Loop Until HslBagi <= 1
Biner = HslBagi & sisa & Hsltemp
Biner = Right("0000000" & Biner, 7)
End Function
Private Function CharHex(ByVal Txt As String, ByVal bit As Integer)
'Create 7 bit / 8 bit
'charhex(str,7)-->7 bit for receiving SMS
'charhex(str,8)-->8 bit for send
Dim i As Integer, bin As String, nbin As String, n As String
Dim bil As Integer, sisa As Integer, lbin As Integer, nol As String
bin = ""
nbin = ""

If bit = 7 Then
    For i = 1 To Len(Txt) Step 2
        n = Mid(Txt, i, 2)
        bin = HexToBin(n) & bin
    Next
    bil = Len(bin) \ bit
    sisa = Len(bin) Mod bit
    
    
    For i = 1 To (Len(bin) - sisa) Step bit
'        Debug.Print Chr$(HexToDec(BinToHex(Mid(bin, i + sisa, bit)))) & vbTab & _
            HexToDec(BinToHex(Mid(bin, i + sisa, bit))) & vbTab & _
            BinToHex(Mid(bin, i + sisa, bit)) & vbTab & _
            Mid(bin, i + sisa, bit)
            
'            DecToGsmAlfa(sDec As String)
        nbin = DecToGsmAlfa(HexToDec(BinToHex(Mid(bin, i + sisa, bit)))) & nbin
            
'        nbin = Chr$(HexToDec(BinToHex(Mid(bin, i + sisa, bit)))) & nbin
    Next
Else
    For i = 1 To Len(Txt)
        n = Mid(Txt, i, 1)
        bin = Biner(Asc(n)) & bin
    Next
    sisa = Len(bin) Mod bit

    If sisa > 0 Then
        For i = 1 To bit - sisa
            nol = nol & "0"
        Next
    End If

    bin = nol & bin
    bil = Len(bin) \ bit
    For i = 1 To bil
        nbin = nbin & BinToHex(Mid(bin, Len(bin) + 1 - bit * i, bit))
    Next
End If
CharHex = nbin
End Function
Private Function CharHexRus(Txt As String)
'  
Dim i As Integer
Dim sTmpStr As String
Dim sResStr As String
Debug.Print Txt
For i = 1 To Len(Txt) Step 4
    sTmpStr = Mid(Txt, i, 4)
    Debug.Print sTmpStr
    Select Case sTmpStr
    Case "0451"     '
        sResStr = sResStr & ""
    Case "0401"     '
        sResStr = sResStr & ""
    Case Else
        Select Case Left(sTmpStr, 2)
        Case "00"   '  
            sResStr = sResStr & Chr(CDec("&H" & sTmpStr))
        Case "04"   '
            sResStr = sResStr & Chr(CDec("&H" & sTmpStr) - 848)
        End Select
    End Select
Next i
CharHexRus = sResStr
End Function




Private Function BinToHex(ByVal Biner As String) As String
Dim bin As String, n As String, nil As String, i As Integer
bin = ""
Biner = Right("00000000" & Biner, 8)
For i = 1 To 2
    bin = Mid(Biner, Len(Biner) + 1 - 4 * i, 4)
    Select Case bin
        Case "0000": n = "0"
        Case "0001": n = "1"
        Case "0010": n = "2"
        Case "0011": n = "3"
        Case "0100": n = "4"
        Case "0101": n = "5"
        Case "0110": n = "6"
        Case "0111": n = "7"
        Case "1000": n = "8"
        Case "1001": n = "9"
        Case "1010": n = "A"
        Case "1011": n = "B"
        Case "1100": n = "C"
        Case "1101": n = "D"
        Case "1110": n = "E"
        Case "1111": n = "F"
    End Select
    nil = n & nil
Next
BinToHex = nil
End Function
Private Function HexToBin(ByVal Biner As String) As String
Dim bin As String, n As String, nil As String, i As Integer
bin = ""
For i = 1 To Len(Biner)
    bin = Mid(Biner, i, 1)
    Select Case bin
        Case "0": n = "0000"
        Case "1": n = "0001"
        Case "2": n = "0010"
        Case "3": n = "0011"
        Case "4": n = "0100"
        Case "5": n = "0101"
        Case "6": n = "0110"
        Case "7": n = "0111"
        Case "8": n = "1000"
        Case "9": n = "1001"
        Case "A": n = "1010"
        Case "B": n = "1011"
        Case "C": n = "1100"
        Case "D": n = "1101"
        Case "E": n = "1110"
        Case "F": n = "1111"
    End Select
    nil = nil & n
Next
HexToBin = nil
End Function
Private Function ConvToChar(ByVal hx As String) As String
Dim i As Integer, tx As String
For i = 1 To Len(hx) Step 2
    tx = tx & Chr(HexToDec(Mid(hx, i, 2)))
Next
ConvToChar = tx
End Function
Private Function HexToDec(ByVal x As String) As Integer
Dim m As String, i As Byte, nil As Integer, n As Integer
For i = 1 To 2
    m = Mid(x, i, 1)
    Select Case UCase(m)
        Case "A": n = 10
        Case "B": n = 11
        Case "C": n = 12
        Case "D": n = 13
        Case "E": n = 14
        Case "F": n = 15
        Case Else: n = CInt(m)
    End Select
    If i = 1 Then
        nil = n * 16
    Else
        nil = nil + n
    End If
Next
HexToDec = nil
End Function
Private Function DecToHex(ByVal x As Integer) As String
'    
Dim nil As String: nil = Hex(x)
If Len(nil) = 1 Then nil = "0" & nil
DecToHex = nil
End Function
Private Function RevNum(ByVal numb As String) As String
' 
Dim s As Integer, ma As String, b As String, a As String, ta As String
s = 1
ma = ""
While (s <= Len(numb))
    ta = Mid(numb, s, 2)
    a = Mid(ta, 1, 1)
    b = Mid(ta, 2, 1)
    If b = "" Then b = "F"
    ma = ma & b & a
    s = s + 2
Wend
RevNum = ma
End Function


Private Function DecToGsmAlfa(sDec As String) As String
Select Case sDec ' Dec   GSM Default alphabet
Case 0:   DecToGsmAlfa = "@"
Case 1:   DecToGsmAlfa = "?"
Case 2:   DecToGsmAlfa = "$"
Case 3:   DecToGsmAlfa = "?"
Case 4:   DecToGsmAlfa = "?"
Case 5:   DecToGsmAlfa = "?"
Case 6:   DecToGsmAlfa = "?"
Case 7:   DecToGsmAlfa = "?"
Case 8:   DecToGsmAlfa = "?"
Case 9:   DecToGsmAlfa = "?"
Case 10:  DecToGsmAlfa = Chr(10)
Case 11:  DecToGsmAlfa = "?"
Case 12:  DecToGsmAlfa = "?"
Case 13:  DecToGsmAlfa = Chr(13)
Case 14:  DecToGsmAlfa = "?"
Case 15:  DecToGsmAlfa = "?"
Case 16:  DecToGsmAlfa = "?"
Case 17:  DecToGsmAlfa = "_"
Case 18:  DecToGsmAlfa = "?"
Case 19:  DecToGsmAlfa = "?"
Case 20:  DecToGsmAlfa = "?"
Case 21:  DecToGsmAlfa = "?"
Case 22:  DecToGsmAlfa = "?"
Case 23:  DecToGsmAlfa = "?"
Case 24:  DecToGsmAlfa = "?"
Case 25:  DecToGsmAlfa = "?"
Case 26:  DecToGsmAlfa = "?"
Case 27:  DecToGsmAlfa = " "
Case 28:  DecToGsmAlfa = "?"
Case 29:  DecToGsmAlfa = "?"
Case 30:  DecToGsmAlfa = "?"
Case 31:  DecToGsmAlfa = "?"
Case 32:  DecToGsmAlfa = " "
Case 33:  DecToGsmAlfa = "!"
Case 34:  DecToGsmAlfa = """"
Case 35:  DecToGsmAlfa = "#"
Case 36:  DecToGsmAlfa = ""
Case 37:  DecToGsmAlfa = "%"
Case 38:  DecToGsmAlfa = "&"
Case 39:  DecToGsmAlfa = "'"
Case 40:  DecToGsmAlfa = "("
Case 41:  DecToGsmAlfa = ")"
Case 42:  DecToGsmAlfa = "*"
Case 43:  DecToGsmAlfa = "+"
Case 44:  DecToGsmAlfa = ","
Case 45:  DecToGsmAlfa = "-"
Case 46:  DecToGsmAlfa = "."
Case 47:  DecToGsmAlfa = "/"
Case 48:  DecToGsmAlfa = "0"
Case 49:  DecToGsmAlfa = "1"
Case 50:  DecToGsmAlfa = "2"
Case 51:  DecToGsmAlfa = "3"
Case 52:  DecToGsmAlfa = "4"
Case 53:  DecToGsmAlfa = "5"
Case 54:  DecToGsmAlfa = "6"
Case 55:  DecToGsmAlfa = "7"
Case 56:  DecToGsmAlfa = "8"
Case 57:  DecToGsmAlfa = "9"
Case 58:  DecToGsmAlfa = ":"
Case 59:  DecToGsmAlfa = ";"
Case 60:  DecToGsmAlfa = "<"
Case 61:  DecToGsmAlfa = "="
Case 62:  DecToGsmAlfa = ">"
Case 63:  DecToGsmAlfa = "?"
Case 64:  DecToGsmAlfa = "?"
Case 65:  DecToGsmAlfa = "A"
Case 66:  DecToGsmAlfa = "B"
Case 67:  DecToGsmAlfa = "C"
Case 68:  DecToGsmAlfa = "D"
Case 69:  DecToGsmAlfa = "E"
Case 70:  DecToGsmAlfa = "F"
Case 71:  DecToGsmAlfa = "G"
Case 72:  DecToGsmAlfa = "H"
Case 73:  DecToGsmAlfa = "I"
Case 74:  DecToGsmAlfa = "J"
Case 75:  DecToGsmAlfa = "K"
Case 76:  DecToGsmAlfa = "L"
Case 77:  DecToGsmAlfa = "M"
Case 78:  DecToGsmAlfa = "N"
Case 79:  DecToGsmAlfa = "O"
Case 80:  DecToGsmAlfa = "P"
Case 81:  DecToGsmAlfa = "Q"
Case 82:  DecToGsmAlfa = "R"
Case 83:  DecToGsmAlfa = "S"
Case 84:  DecToGsmAlfa = "T"
Case 85:  DecToGsmAlfa = "U"
Case 86:  DecToGsmAlfa = "V"
Case 87:  DecToGsmAlfa = "W"
Case 88:  DecToGsmAlfa = "X"
Case 89:  DecToGsmAlfa = "Y"
Case 90:  DecToGsmAlfa = "Z"
Case 91:  DecToGsmAlfa = "?"
Case 92:  DecToGsmAlfa = "?"
Case 93:  DecToGsmAlfa = "?"
Case 94:  DecToGsmAlfa = "?"
Case 95:  DecToGsmAlfa = ""
Case 96:  DecToGsmAlfa = "?"
Case 97:  DecToGsmAlfa = "a"
Case 98:  DecToGsmAlfa = "b"
Case 99:  DecToGsmAlfa = "c"
Case 100: DecToGsmAlfa = "d"
Case 101: DecToGsmAlfa = "e"
Case 102: DecToGsmAlfa = "f"
Case 103: DecToGsmAlfa = "g"
Case 104: DecToGsmAlfa = "h"
Case 105: DecToGsmAlfa = "i"
Case 106: DecToGsmAlfa = "j"
Case 107: DecToGsmAlfa = "k"
Case 108: DecToGsmAlfa = "l"
Case 109: DecToGsmAlfa = "m"
Case 110: DecToGsmAlfa = "n"
Case 111: DecToGsmAlfa = "o"
Case 112: DecToGsmAlfa = "p"
Case 113: DecToGsmAlfa = "q"
Case 114: DecToGsmAlfa = "r"
Case 115: DecToGsmAlfa = "s"
Case 116: DecToGsmAlfa = "t"
Case 117: DecToGsmAlfa = "u"
Case 118: DecToGsmAlfa = "v"
Case 119: DecToGsmAlfa = "w"
Case 120: DecToGsmAlfa = "x"
Case 121: DecToGsmAlfa = "y"
Case 122: DecToGsmAlfa = "z"
Case 123: DecToGsmAlfa = "?"
Case 124: DecToGsmAlfa = "?"
Case 125: DecToGsmAlfa = "?"
Case 126: DecToGsmAlfa = "?"
Case 127: DecToGsmAlfa = "?"
End Select
End Function



















